import 'package:flutter/material.dart';
import 'package:get/get.dart';
import 'package:stateful_provider/controller/status_controller.dart';

class StatusWidget extends StatelessWidget {
  Future Function(DartError error) consumeError;
  bool Function(bool current)? loading;
  final Widget process;

  StatusWidget({
    required this.consumeError,
    this.loading,
    this.process = const CircularProgressIndicator(),
  });

  StatusController _status = Get.find();

  @override
  Widget build(BuildContext context) => Container(
        child: Obx(() {
          if (_status.hasError) {
            final current = _status.currentError();
            if (current != null) {
              WidgetsBinding.instance?.addPostFrameCallback((timeStamp) async {
                _status.consumeError(current);
                await consumeError(current);
              });
            }
          }
          final isLoading = loading?.call(_status.isProcessing.value) ??
              _status.isProcessing.value;
          return isLoading ? process : SizedBox();
        }),
      );
}
